Name:       perl-mogilefs-server
Version:    2.36
Release:    16%{?dist}
Summary:    Server part of the MogileFS distributed filesystem
License:    GPL+ or Artistic
Group:      System Environment/Daemons
URL:        http://search.cpan.org/dist/mogilefs-server/
Source0:    http://search.cpan.org/CPAN/authors/id/D/DO/DORMANDO/mogilefs-server-%{version}.tar.gz
Source1:    mogstored.service
Source2:    mogilefsd.service
Source3:    mogilefsd.conf
Source4:    mogilefs.conf
Patch0:     mogilefs-remove_deps.patch
BuildArch:  noarch
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  perl
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  make
BuildRequires:  sed
BuildRequires:  systemd
# Run-time:
BuildRequires:  perl(base)
BuildRequires:  perl(bytes)
BuildRequires:  perl(BSD::Resource)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Config)
BuildRequires:  perl(constant)
BuildRequires:  perl(DBD::Pg)
BuildRequires:  perl(DBD::SQLite) >= 1.13
BuildRequires:  perl(DBD::mysql)
BuildRequires:  perl(DBI)
BuildRequires:  perl(Danga::Socket)
BuildRequires:  perl(Devel::Peek)
BuildRequires:  perl(Digest::MD5)
BuildRequires:  perl(Errno)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(Fcntl)
BuildRequires:  perl(fields)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Copy)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(FindBin)
BuildRequires:  perl(Getopt::Long)
BuildRequires:  perl(HTTP::Date)
BuildRequires:  perl(HTTP::Request)
BuildRequires:  perl(HTTP::Response)
BuildRequires:  perl(IO::File)
BuildRequires:  perl(IO::Handle)
# IO::KQueue not used
BuildRequires:  perl(IO::Poll)
BuildRequires:  perl(IO::Socket)
BuildRequires:  perl(IO::Socket::INET)
BuildRequires:  perl(IO::Socket::INET6)
BuildRequires:  perl(IO::Socket::SSL) >= 0.98
BuildRequires:  perl(LWP)
BuildRequires:  perl(LWP::UserAgent)
BuildRequires:  perl(List::Util)
BuildRequires:  perl(Net::Netmask)
BuildRequires:  perl(overload)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(Perlbal)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(Socket)
BuildRequires:  perl(Storable)
BuildRequires:  perl(strict)
BuildRequires:  perl(Symbol)
BuildRequires:  perl(Sys::Hostname)
BuildRequires:  perl(Sys::Syslog)
BuildRequires:  perl(URI)
BuildRequires:  perl(vars)
BuildRequires:  perl(warnings)
# Tests:
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(Time::HiRes)
# Optional tests:
BuildRequires:  perl(MogileFS::Client)
# Skip perl-MogileFS-Utils for mogadm tool because the tests require system
# MySQL RDBMS running.
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Provides:       mogilefs-server = %{version}-%{release}
Obsoletes:      mogilefs-server < 2.17-5

# Remove mogstored backends and Perlbal from Requires:
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((Mogstored::HTTPServer::.*|Perlbal)\\)

%description
Server part of the MogileFS distributed filesystem


%package -n mogilefsd
Summary:        MogileFS tracker daemon
Group:          System Environment/Daemons
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:       mogilefsd-storage
Recommends:     mogilefsd-storage-mysql
Requires(pre):      glibc-common
Requires(pre):      shadow-utils
Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd

%description -n mogilefsd
This is MogileFS tracker daemon. It supports various storages. After selecting
one, you have to install corresponding storage backend (mogilefsd-storage-*
packages), adjust %{_sysconfdir}/mogilefs/mogilefsd.conf, and configure and
start the storage DBMS before the mogilefsd.service.


%package -n mogilefsd-storage-mysql
Summary:        MySQL storage for MogileFS tracker daemon
Group:          System Environment/Daemons
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Provides:       mogilefsd-storage

%description -n mogilefsd-storage-mysql
%{summary}.


%package -n mogilefsd-storage-postgres
Summary:        PostgreSQL storage for MogileFS tracker daemon
Group:          System Environment/Daemons
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Provides:       mogilefsd-storage

%description -n mogilefsd-storage-postgres
%{summary}.


%package -n mogilefsd-storage-sqlite
Summary:        SQLite storage for MogileFS tracker daemon
Group:          System Environment/Daemons
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Provides:       mogilefsd-storage

%description -n mogilefsd-storage-sqlite
%{summary}.


%package -n mogstored
Summary:        MogileFS storage daemon
Group:          System Environment/Daemons
BuildRequires:  perl(Gearman::Client::Async)
BuildRequires:  perl(Gearman::Server)
Requires:       sysstat
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:       perl(Mogstored::HTTPServer::None)
Requires(pre):      glibc-common
Requires(pre):      shadow-utils
Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd

%description -n mogstored
The MogileFS storage daemon mogstored


%package -n mogstored-backend-perlbal
Summary:    Perlbal backend for mogstored
Group:      System Environment/Daemons
BuildRequires: perl(Perlbal) >= 1.75
Requires:   perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:   perl(Mogstored::HTTPServer)
Requires:   Perlbal

%description -n mogstored-backend-perlbal
Perlbal backend for mogstored, the MogileFS storage daemon


%package -n mogstored-backend-apache
Summary:    Apache backend for mogstored
Group:      System Environment/Daemons
Requires:   httpd
Requires:   perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:   perl(Mogstored::HTTPServer)

%description -n mogstored-backend-apache
Apache backend for mogstored, the MogileFS storage daemon


%package -n mogstored-backend-lighttpd
Summary:    LigHTTPd backend for mogstored
Group:      System Environment/Daemons
Requires:   lighttpd
Requires:   perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:   perl(Mogstored::HTTPServer)

%description -n mogstored-backend-lighttpd
LigHTTPd backend for mogstored, the MogileFS storage daemon


%package -n mogstored-backend-none
Summary:    Backend which allows mogstored to work with unmanaged DAV servers
Group:      System Environment/Daemons
Requires:   perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:   perl(Mogstored::HTTPServer)

%description -n mogstored-backend-none
Backend which allows mogstored to work with unmanaged DAV servers


%prep
%setup -q -n mogilefs-server-%{version}
%patch0 -p1
rm -rv lib/mogdeps
# Remove test that interfere with system service
rm t/mogstored-shutdown.t
sed -i -e '/^t\/mogstored-shutdown\.t/d' MANIFEST


%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}


%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}/*

install -d -m0755 %{buildroot}%{_unitdir}
install -p -m0644 %{SOURCE1} %{buildroot}%{_unitdir}/mogstored.service
install -p -m0644 %{SOURCE2} %{buildroot}%{_unitdir}/mogilefsd.service

install -d -m0755 %{buildroot}%{_sysconfdir}/mogilefs
install -p -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/mogilefs/mogilefsd.conf
install -p -m0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/mogilefs/mogilefs.conf


%check
make test


%pre -n mogilefsd
getent group mogilefsd >/dev/null || groupadd -r mogilefsd
getent passwd mogilesd >/dev/null || \
    useradd -r -g mogilefsd -d / -s /sbin/nologin \
    -c "MogileFS tracker daemon" mogilefsd
exit 0

%post -n mogilefsd
%systemd_post mogilefsd.service

%preun -n mogilefsd
%systemd_preun mogilefsd.service

%postun -n mogilefsd
%systemd_postun_with_restart mogilefsd.service

%pre -n mogstored
getent group mogstored >/dev/null || groupadd -r mogstored
getent passwd mogstored >/dev/null || \
    useradd -r -g mogstored -d / -s /sbin/nologin \
    -c "MogileFS storage daemon" mogstored
exit 0

%post -n mogstored
%systemd_post mogstored.service

%preun -n mogstored
%systemd_preun mogstored.service

%postun -n mogstored
%systemd_postun_with_restart mogstored.service

%files -n mogilefsd
%doc CHANGES TODO doc/
%{_bindir}/mogilefsd
%{_bindir}/mogdbsetup
%{_mandir}/man1/mogilefsd.*
%{_mandir}/man3/MogileFS::*.*
%exclude %{_mandir}/man3/MogileFS::Store::*
%{perl_vendorlib}/MogileFS
%exclude %{perl_vendorlib}/MogileFS/Store/*
%dir %{_sysconfdir}/mogilefs
%config(noreplace) %{_sysconfdir}/mogilefs/mogilefs.conf
%config(noreplace) %attr(0640,root,mogilefsd) %{_sysconfdir}/mogilefs/mogilefsd.conf
%{_unitdir}/mogilefsd.service

%files -n mogilefsd-storage-mysql
%{_mandir}/man3/MogileFS::Store::MySQL.*
%{perl_vendorlib}/MogileFS/Store/MySQL.pm

%files -n mogilefsd-storage-postgres
%{_mandir}/man3/MogileFS::Store::Postgres.*
%{perl_vendorlib}/MogileFS/Store/Postgres.pm

%files -n mogilefsd-storage-sqlite
%{_mandir}/man3/MogileFS::Store::SQLite.*
%{perl_vendorlib}/MogileFS/Store/SQLite.pm

%files -n mogstored
%{_bindir}/mogstored
%{_bindir}/mogautomount
%{_mandir}/man1/mogstored.*
%{_mandir}/man1/mogautomount.*
%dir %{perl_vendorlib}/Mogstored
%{perl_vendorlib}/Mogstored/ChildProcess*
%{perl_vendorlib}/Mogstored/FIDStatter.pm
%{perl_vendorlib}/Mogstored/HTTPServer.pm
%{perl_vendorlib}/Mogstored/SideChannel*
%{_unitdir}/mogstored.service

%files -n mogstored-backend-perlbal
%{perl_vendorlib}/Mogstored/HTTPServer/Perlbal.pm

%files -n mogstored-backend-apache
%{perl_vendorlib}/Mogstored/HTTPServer/Apache.pm

%files -n mogstored-backend-lighttpd
%{perl_vendorlib}/Mogstored/HTTPServer/Lighttpd.pm

%files -n mogstored-backend-none
%{perl_vendorlib}/Mogstored/HTTPServer/None.pm


%changelog
* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.36-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct 29 2015 Petr Pisar <ppisar@redhat.com> - 2.36-15
- Modernize specification file
- Migrate from System V init scripts to systemd
- Package PostgreSQL and SQLite mogilefsd storages
- Restrict access to mogilefsd.conf because it can contain password

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 06 2015 Jitka Plesnikova <jplesnik@redhat.com> - 2.36-13
- Perl 5.22 rebuild

* Thu Aug 28 2014 Jitka Plesnikova <jplesnik@redhat.com> - 2.36-12
- Perl 5.20 rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 24 2013 Petr Pisar <ppisar@redhat.com> - 2.36-9
- Perl 5.18 rebuild
- Specify all dependencies

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun Jun 17 2012 Petr Pisar <ppisar@redhat.com> - 2.36-6
- Perl 5.16 rebuild

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Jul 20 2011 Petr Sabata <contyk@redhat.com> - 2.36-4
- Perl mass rebuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Dec 20 2010 Marcela Maslanova <mmaslano@redhat.com> - 2.36-2
- 661697 rebuild for fixing problems with vendorach/lib

* Thu Jun 24 2010 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.36-1
- Upstream released new version

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 2.30-4
- rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.30-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.30-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Jan 19 2009 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.30-1
- Upstream released new version

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-4
- Add the 'None' backend

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-3
- Remove the included dependencies before building, not after

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-2
- Remove included dependencies

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-1
- Upstream released new version

* Wed Aug 13 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-7
- Add compat statements for subpackages

* Wed Aug 13 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-6
- Due to a problem in the tempfile handling, mogilefs occasionally 
  looses file data after a while. Bz 458890

* Sat Feb 09 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-5
- Rename package to respect the Naming Guidelines

* Sat Jan 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-4
- Require Perlbal instead of perlbal
- Remove autogenerated Perlbal dependency from mogstored

* Sat Jan 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-3
- Add Requires for perlbal to perlbal backend
- Rename package
- Remove failing test

* Thu Sep 06 2007 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-2
- Add missing BRs (#252257)
* Sun May 20 2007 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-1
- Initial import

